<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

class City extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /**
     * Get the Region that owns the City.
     */
    public function region()
    {
        return $this->belongsTo('App\Region')->with('country');
    }
    /***
     * List Cities
     *
     * @return mixed
     */
    public function listCities(Request $request)
    {
        $data = $this::orderBy('id', 'Desc');
        if ($request->search_name != '') {
            $data->where(function ($query) use ($request) {
                return $query
                    ->Where('name', 'like', '%' . $request->search_name . '%');
            });
        }
        return $data->paginate(session()->get('site_settings')['results_per_page']);
    }
    /***
     * Insert/Update City
     *
     * @return mixed
     */
    public function InsertOrUpdateCity(Request $request,$id=0)
    {
        if($id>0){
            $city=$this->findOrFail($id);
        }else{
            $city=new $this();
        }

        $city->region_id= $request->input('region');
        $city->name= $request->input('name');
        if($city->save()){
            return true;
        }else{
            return false;
        }
    }
}
