<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Auth;

class TargetVisit extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /***
     * List TargetVisit
     *
     * @return mixed
     */
    public function listTargetVisits(Request $request)
    {
        $data = $this::where('agency_id',Auth::user()->agency_id)->orderBy('id', 'Asc');
        if ($request->search_name != '') {
            $data->where(function ($query) use ($request) {
                return $query
                    ->Where('grade', 'like', '%' . $request->search_name . '%');
            });
        }
        return $data->paginate(session()->get('site_settings')['results_per_page']);
    }
    /***
     * Insert/Update TargetVisit
     *
     * @return mixed
     */
    public function InsertOrUpdateTargetVisit(Request $request,$id=0)
    {
        if($id>0){
            $target_visit=$this->findOrFail($id);
        }else{
            $target_visit=new $this();
        }
        $target_visit->grade= $request->input('grade');
        $target_visit->value= $request->input('value');
        $target_visit->agency_id =  Auth::user()->agency_id;
        if($target_visit->save()){
            return true;
        }else{
            return false;
        }
    }
}
